#!/usr/bin/python
# -*- coding: utf-8 -*-

# _Platform/Youtube.py
#
# This file is part of BotMU
#
# Author: Raphaël Perraudeau <r.perraudeau@gmail.com>
# Copyright: 2011 Raphaël Perraudeau <r.perraudeau@gmail.com>
# Licence: GNU/GPL
#
# Home page: <http://botmu.sourceforge.net/>


import os
import sys
import datetime

from PyQt4.QtCore import *

from commonFunctions import *
from httpReq import *


#############################################################################
class Abort(Exception):
	"""classe d'exception crée pour l'arrêt du téléchargement avant la fin"""
	pass
 
#############################################################################
class Telecharger(QThread):
	"""Thread de téléchargement"""

	#========================================================================
	def __init__(self, fileList, destination, parent=None):
		super(Telecharger,self).__init__()
		self.destination = destination
		self.stop = False
		self.httpreq = httpReq(parent.configDir)
		self.fileRunning = ""
		self.downloadingFile = 0
		self.parent = parent
		self.fileList = fileList
		self.row = 0
		
		setupFile = os.path.join(self.parent.configDir, "setup.ini")
		paramfile = open(setupFile)
		param = (paramfile.read()).split("\n")
		for item in param:
			if item.split("=")[0] == 'proxy':
				self.proxy = item.split("=")[1]
				self.httpreq.defineProxy(self.proxy)
			if item.split("=")[0] == 'useragent':
				self.useragent = item.split("=")[1]
				self.httpreq.defineUseragent(self.useragent)
			if item.split("=")[0] == 'verbose':
				self.verbose = item.split("=")[1]
				self.httpreq.defineVerbose(int(self.verbose))
			if item.split("=")[0] == 'limit':
				self.limit = item.split("=")[1]
				self.httpreq.defineLimit(int(self.limit))

			
			
	def run(self):
		self.stop = False
		self.row = 0
		while self.fileList:
			if len(self.fileList)>self.row:
				if(self.fileList[self.row][1]=="auto"):
					self.filename = self.getFileName(self.fileList[self.row][0])
					self.fileList[self.row][1] = self.filename
					self.msgInf = [u"Récupération des noms de fichier...", 1]
					self.infotelech(0, 0, 0)
			else:
				break
			self.row+=1
			
		self.row = 0
		while self.fileList:
			if len(self.fileList)>self.row:
				LinkSrc = self.fileList[self.row][0]
				dest = self.fileList[self.row][1]
				continuedl = self.fileList[self.row][3]
				if(continuedl != 100):
					self.downloadingFile = self.row
					self.downloadFile(LinkSrc, dest, continuedl)
			else:
				break
			self.row+=1
	
	#http://www.megaupload.com/?d=AGI7OZ4M
	#========================================================================
	def getFileName(self, LinkSrc):
		error = False
		fileDlEnd = False
		try:
			LinkSrc = str(LinkSrc)
		except OSError, e:
			error = True
			messagefin = u"Erreur OS: function DownloadFile: %s" % e
			logError("_Platform - YT - downloadFile - 1", sys.exc_info()[0], sys.exc_info()[1])
		except:
			logError("_Platform - YT - downloadFile - 2", sys.exc_info()[0], sys.exc_info()[1])
		if not error:
			page = 0
			try:
				page = self.httpreq.getPage(LinkSrc)
				if not isInt(page):
					html = page.read()
					dest = html.split('<meta name="title" content="')
					if len(dest)>1:
						dest = html.split('<meta name="title" content="')[1].split('">')[0]
						dest = htmlentities_decode(dest.decode("utf-8"))
						dest = "%s.flv" % dest
					else:
						dest = u"Le lien indiqué n'est pas un lien Youtube valide"
				else:
					if page == -1:
						dest = u"Téléchargement stoppé"
					elif page == -2:
						dest = u"l'Url est invalide"
					elif page == -3:
						dest = u"Impossible de contacter l'url, verifier la disponibilité du lien"
					else:
						dest = u"Autre: Erreur %s" % page
						logError("_Platform - YT - downloadFile - 2", sys.exc_info()[0], sys.exc_info()[1])
			except Abort:
				dest = u"Téléchargement stoppé"
			except:
				dest = u"l'Url est invalide ou pas de connexion internet 2"
				logError("_Platform - YT - downloadFile - 3", sys.exc_info()[0], sys.exc_info()[1])
		return dest
	
	
	
	#http://www.megaupload.com/?d=AGI7OZ4M
	#========================================================================
	def downloadFile(self, LinkSrc, dest, continuedl=0):
		error = False
		fileDlEnd = False
		try:
			LinkSrc = str(LinkSrc)
			dest = str(dest)
		except OSError, e:
			error = True
			messagefin = u"Erreur OS: function DownloadFile: %s" % e
			logError("_Platform - YT - downloadFile - 1", sys.exc_info()[0], sys.exc_info()[1])
		except:
			logError("_Platform - YT - downloadFile - 2", sys.exc_info()[0], sys.exc_info()[1])
		if not error:
			page = 0
			try:
				self.filename = dest
				self.msgInf = [u"Contact de %s..." % (LinkSrc), 1]
				self.infotelech(0, 0, 0)
				page = self.httpreq.getPage(LinkSrc)
				html = page.read()
				
				link = html.split('class="flash-player"')
				
				if len(link)>1 :
					link = link[1].split("<noembed>")[0]
					try:
						link = link.split("fmt_url_map")[1]
						link = link.split("&amp;")[0]
						links = link.split("http%3A%2F%2F")[1:-1]
					except:
						link = link.split("url_encoded_fmt_stream_map")[1].split("&amp;")[0]
						link = urldecode(link)
						links = link.split("http%3A%2F%2F")[1:-1]
						
				
					if self.filename == "auto":
						self.filename = html.split('<meta name="title" content="')[1].split('">')[0]
						self.filename = self.filename.decode("utf-8")
						self.filename = "%s.flv" % self.filename
						self.infotelech(0, 0, 0)
					
					for link in links:
						link = urldecode(link).split(",")[0]
						link = "http://%s" % link
						dest = os.path.join(self.destination, self.filename)
						self.msgInf = [u"Téléchargement de %s en cours" % (self.filename), 2]
						self.fileRunning = LinkSrc

						self.httpreq.defineContinue(continuedl)
						page = self.httpreq.getPage(link, dest=dest, report_hook=self.infotelech)
						self.httpreq.defineContinue(0)
						
						if not isInt(page):
							break
						
					self.fileRunning = ''
					if isInt(page):
						if page == -1:
							messagefin = u"Téléchargement stoppé"
						elif page == -2:
							messagefin = u"l'Url est invalide"
						elif page == -3:
							messagefin = u"Impossible de contacter l'url, verifier la disponibilité du lien"
						else:
							messagefin = u"Autre: Erreur %s" % page
							logError("_Platform - YT - downloadFile - 2", sys.exc_info()[0], sys.exc_info()[1])
					elif self.stop == True:
						messagefin = u"Téléchargement stoppé"
					else:
						messagefin = u"Téléchargement terminé\n\n"
				else:
					messagefin = u"Le lien indiqué n'est pas un lien Youtube valide"
			except Abort:
				messagefin = u"Téléchargement stoppé"
			except:
				messagefin = u"l'Url est invalide ou pas de connexion internet 2"
				logError("_Platform - YT - downloadFile - 3", sys.exc_info()[0], sys.exc_info()[1])
		if self.parent.appMethod == "gui":
			self.emit(SIGNAL("fintelech(PyQt_PyObject)"), [messagefin, self.row, "Youtube"])
		else:
			self.parent.fintelech([messagefin, self.row, "Youtube"])

	#========================================================================
	def infotelech(self, telechbloc, taillebloc, totalblocs):
		"""reçoit les infos de progression du téléchargement"""
		# nécessaire pour stopper le téléchargement avant la fin
		if self.stop:
			raise Abort
		# envoie les infos de progression à la fenêtre graphique
		if self.parent.appMethod == "gui":
			self.emit(SIGNAL("infotelech(PyQt_PyObject)"), [telechbloc, taillebloc, totalblocs, self.msgInf, self.row, self.filename, "Youtube"])
		else:
			self.parent.infotelech([telechbloc, taillebloc, totalblocs, self.msgInf, self.row, self.filename, "Youtube"])
		
 
	#========================================================================
	def stoptelech(self):
		# permet l'arrêt du téléchargement avant la fin
		self.stop = True
		
	#========================================================================
	def pausetelech(self):
		# permet la pause du téléchargement
		if self.httpreq.pause == True:
			self.httpreq.pause = False
		else:
			self.httpreq.pause = True
			
	#========================================================================
	def stopthisfile(self):
		self.httpreq.stopthisfile = True
